package br.usp.ime.prolog.actions;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.swt.widgets.Shell;

import br.usp.ime.prolog.launch.PrologConsole;

/**
 * @author Juliana
 *
 * Calls a Prolog console (session).
 * (Prolog console path must have been informed at the correct preference
 * page field).
 */
public class PrologConsoleAction implements IWorkbenchWindowActionDelegate {
	IWorkbenchWindow activeWindow = null;


	/* (non-Javadoc)
	 * @see org.eclipse.ui.IWorkbenchWindowActionDelegate#dispose()
	 */
	public void dispose() {
		//  Nothing to do.
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IWorkbenchWindowActionDelegate#init(org.eclipse.ui.IWorkbenchWindow)
	 */
	public void init(IWorkbenchWindow window) {
		activeWindow = window;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IActionDelegate#run(org.eclipse.jface.action.IAction)
	 */
	public void run(IAction proxyAction) {
		try {
			//MessageDialog.openInformation(null, "Testando", "Testando!");
			PrologConsole console = new PrologConsole(null,null);
		}		
		catch (CoreException e) {
			Shell shell = activeWindow.getShell();
			MessageDialog.openInformation(shell, "Executing Prolog Interpreter...", "ERROR: Prolog interpreter path may be incorrect! Check the 'Prolog Preferences'.");
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IActionDelegate#selectionChanged(org.eclipse.jface.action.IAction, org.eclipse.jface.viewers.ISelection)
	 */
	public void selectionChanged(IAction arg0, ISelection arg1) {
		// Do nothing, action is not dependent on the selection.
	}

}
